//*********************************************************************\\
//              Class List ohjelmalle hiihto.java                      \\
//*********************************************************************\\

//import Time;
//import Reformat;
import java.io.*;
import java.util.*;
//import Parser;

public class List   {

        private Knot alku;


  public List()   {
        alku = null;
        }


  public void addToList(Knot Newest) throws IOException   {
        String top;
        boolean not_on_List=true;

        Knot ptr = alku;
        Knot prev = null;

        while (ptr != null && ptr.getLaika() <= Newest.getLaika())   {
                if (ptr.getNumero() == Newest.getNumero())   {
                        System.out.println("***INFO: This competitornumber is taken");
                        System.out.print("***Press ENTER to continue");
                        top = Parser.readLine();
						not_on_List = false;
						ptr = null;
                        }
                else    {
                        prev = ptr;
                        ptr = ptr.Seuraava();
                        }
                }

        if ( not_on_List )   {
                if ( prev != null )
                        prev.add(Newest);
                else
                        alku = Newest;
                
				if ( ptr != null ) Newest.add(ptr);				
		 		}
        } //metodin loppu


  public void removeFromList( int poistettava )   {
        Knot ptr = alku;
        Knot prev = null;

        if (ptr != null)   {
                while (ptr != null)   {
                        if (ptr.getNumero() == poistettava)   {
                                if (ptr == alku)   {
                                        alku = alku.Seuraava();
                                        ptr.setNextNull();
                                        return;
                                        }//sisin IF
                                else   {
                                        prev.add(ptr.Seuraava());
                                        ptr.setNextNull();
                                        return;
                                        }//ELSE
                                }//sisempi IF

                        prev = ptr;
                        ptr = ptr.Seuraava();
                        }//WHILE
                System.out.println("***INFO: Competitor NOT on List");
                }//IF
        else   {
                System.out.println("***ERROR: List is empty");
                }
        }//removeFromList


  public void output() throws IOException   {
        Knot ptr = alku;
        int rows = 16;
        int count = 1;
        String top;

        System.out.println("CompetitorListing:");
        while (ptr != null)   {
                if (count % rows != 0)   {
                        ptr.output();
                        }
                else   {
                        System.out.println("***MORE [press enter]");
                        top = Parser.readLine();
                        ptr.output();
                        }
                count = count + 1;
                ptr = ptr.Seuraava();
                }//WHILE
        System.out.println(ptr);
        }//output


  public void EraseList()   {
        while (alku != null)   {
                alku = alku.Seuraava();
                }
        System.out.println("***INFO: List is now empty");
        }//EraseList


  public boolean queueNumero(int toFind)   {
        Knot ptr = alku;
        if (ptr != null)   {
                while (ptr != null)   {
                        if (ptr.getNumero() == toFind)   {
                                return true;
                                }//IF sisll
                        ptr = ptr.Seuraava();
                        }//WHILE
                return false;
                }//IF alkup
        else   {
                //System.out.println("***INFO: List is empty");
                return false;
                }//ELSE
        }//queueNumero


  public Knot findKnot(int toFind)   {
        Knot ptr = alku;
        if (ptr != null)   {
                while (ptr != null)   {
                        if (ptr.getNumero() == toFind)   {
                                return ptr;
                                }//IF sisll
                        ptr = ptr.Seuraava();
                        }//WHILE
                return null;
                }//IF
        else   {
                System.out.println("***INFO: List is Empty");
                return null;
                }//ELSE
        }//findKnot


  public void saveToFile(String fileName) throws IOException   {
        BufferedWriter out =
                new BufferedWriter( new FileWriter (fileName/*, true*/ ) );

        Knot ptr = alku;
        String separator = "#";

        while (ptr != null)   {
                out.write( Integer.toString( ptr.getNumero() )
                           +separator+ptr.getNimi()
                           +separator+Integer.toString( ptr.getLuokka() )
                           +separator+Double.toString( ptr.getIHaika() )
                           +separator+Double.toString( ptr.getLaika() ) );
                           
                out.newLine();
                ptr = ptr.Seuraava();
                }//WHILE
        out.close();
        }//saveToFile
                                                                       

  public void readFromFile(String fileName) throws IOException   {
        String temp;    //apumuuttuja tarkastettaessa
                        //onko dataa
        int    temp1;   //Numero
        String temp2;   //Nimi
        int    temp3;   //Luokka
        double temp4;   //IHaika
        double temp5;   //Laika

        StringTokenizer row;
        String separator = "#";

        BufferedReader in;

        try   {
                in = new BufferedReader( new FileReader(fileName) );
                }
        catch (IOException e)   {
                System.out.println("***ERROR: error in opening file "+fileName);
                return;
                }
		System.out.println("***INFO: List loaded succesfully");
        while ( ( temp = in.readLine() ) != null )   {
                row = new StringTokenizer(temp, separator);

                temp1 = Integer.valueOf(row.nextToken()).intValue();
			    Knot Newest = new Knot(temp1);
/*-----------------------------------------------*/			
		/*	TM OSA ON PERIATTEESSA TARPEETON, KOSKA MYS
			ADDTOLIST TARKISTAA MYS ONKO NUMERO VARATTU VAI EI!*/
		
			Knot ptr = alku;
			Knot prev = null;
			boolean not_on_List=true;
			
			while (ptr != null)   {
			if (Newest.getNumero() == ptr.getNumero())   {
				int x = Newest.getNumero();
				System.out.println("***WARNING: List is NOT completely loaded\n***         competitor number "+x+" already excists!");
				ptr = null;
				}//if
			else   {
				prev = ptr;
				ptr = ptr.Seuraava();
				}//else
				}//while
                temp2 = row.nextToken();
                Newest.setNimi(temp2);

                temp3 = Integer.valueOf(row.nextToken()).intValue();
                Newest.setLuokka(temp3);

                temp4 = Double.valueOf(row.nextToken()).doubleValue();
                Newest.setIHaika(temp4);

                temp5 = Double.valueOf(row.nextToken()).doubleValue();
                Newest.setLaika(temp5);
				
				addToList( Newest );
				
/*-----------------------------------------------*/			
                }//WHILE

        in.close();
        }//readFromFile


  public static void sortByTime (Element [] list, int left, int right)   {

        double Pivot;
        int i, j;

        Element temp = new Element();

        if (left < right)   {
                Pivot = list[left].getLaika();
                i = left;
                j = right + 1;

                do{
                  do{
                    i = i + 1;
                    }while (list[i].getLaika() < Pivot && i<right);
                  do{
                    j = j - 1;
                    }while (list[j].getLaika() > Pivot && j>left);
                  if(i<j){
                    temp = list[i];
                    list[i] = list[j];
                    list[j] = temp;
                    }
                }while (i < j);

                temp = list[left];
                list[left] = list[j];
                list[j] = temp;

                sortByTime(list, left, j-1);
                sortByTime(list, j+1, right);

                }   //IF (LEFT < RIGHT)

        }//sortByTime


  public void printList() throws IOException   {

        int i = 0;
        int amount = 0;
        int size = 50;

        Element [] taul = new Element[size];
        Knot ptr = alku;

        while (ptr != null && i<size-1)   {
                taul[i++] = new Element(ptr);
                amount++;
                ptr = ptr.Seuraava();
                }
        System.out.println("All competitors:");
        i = 0;

        while (i < amount)   {
                try   {
                      taul[i].output();
                      i++;
                      }
                catch (Exception e) {
                      System.out.println("***ERROR: error in reading a row");
                      i++;
                      }
                System.out.println();
                }

        sortByTime(taul, 0, amount-1);
        System.out.println("***INFO: end of List");

        }//printList


}
                        










