//*********************************************************************\\
//				   Itse ohjelma HiihtoKisa.java                        \\
//*********************************************************************\\

//import java.util.*;
//import java.text.*;
//import Reformat;
//import Element;
import java.io.*;
//import Time;
//import Knot;
//import List;
//import Parser;

public class HiihtoKisa   {

		public static void main(String [] argv) throws IOException   {

		int Valinta = 20;
		String apu = "";
		List hiihtajat = new List();

		while ( Valinta != 0 )   {

				apu = Parser.readLine("\n***INFO: type (quit) to quit or (ls) for commandlist\n>");
				if (apu.equals("add")) Valinta = 1;
				if (apu.equals("rem")) Valinta = 2;
				if (apu.equals("edit")) Valinta = 3;
				if (apu.equals("search")) Valinta = 4;
				if (apu.equals("l")) Valinta = 5;
				if (apu.equals("rm")) Valinta = 6;
				if (apu.equals("save")) Valinta = 7;
				if (apu.equals("load")) Valinta = 8;
				if (apu.equals("ls")) Valinta = 9;
				if (apu.equals("quit")) Valinta = 0;
				//Valinta = Parser.readInt("***INFO: type (quit) to quit or (ls) for commandlist\n>");
				
				switch ( Valinta )   {
						case 1:  AddHiihtaja(hiihtajat);         break;
						case 2:  RemoveHiihtaja(hiihtajat);      break;
						case 3:  EditHiihtaja(hiihtajat);        break;
						case 4:  SearchHiihtajaNum(hiihtajat);   break;
						case 5:  hiihtajat.output();             break;
						case 6:  RemoveList(hiihtajat);          break;
						case 7:  SaveList(hiihtajat);            break;
						case 8:  LoadList(hiihtajat);            break;
						case 9:  ShowList();					 break;

						case 0:
						System.out.println("***INFO: Quitting...\n\n\n...Bye");
						break;
						}
				}//WHILE
		}//MAIN

  public static void ShowList()   {
				  System.out.println("Make your Decision:");
				  System.out.println("   add    - Add hiihtaja");
				  System.out.println("   rem    - Remove hiihtaja");
				  System.out.println("   edit   - Edit hiihtaja");
				  System.out.println("   search - Search hiihtaja by Numero");
				  System.out.println("   l      - Print list hiihtajat");
				  System.out.println("   rm     - Remove List");
				  System.out.println("   save   - Save List");
				  System.out.println("   load   - Load List");
				  System.out.println("   ls     - Display this list");
				  System.out.println("   --------");
				  System.out.println("   quit   - Quit");
				  System.out.println();
				  }//ShowList

  public static void AddHiihtaja(List omHiihtajat) throws IOException  {

		int Valinta;

		int num = 1;
		String nim;
		int luo;
		double iha;
		double lai;

		boolean found;

		while (num != 0)   {
				System.out.println("***WARNING: Don't use this char in any value: #");
				num = Parser.readInt("    Give competitors number(0-Menu) >");

				found = omHiihtajat.queueNumero(num);

				if ( !found && num > 0 )   {
						Knot New = new Knot(num);
						nim = Parser.readLine  ("    Give competitors name           >");
						  New.setNimi(nim);
						luo = Parser.readInt   ("    Give competitors Class          >");
						  New.setLuokka(luo);
                        
						iha = Parser.readDouble("    Give competitors idealtime(15km)>");
						  New.setIHaika(iha);
							Time arpa = new Time(luo, iha);
							lai = arpa.output();
						  New.setLaika(lai);
												                          
						omHiihtajat.addToList(New);
						omHiihtajat.output();
						}//IF

				else if (num < 0)   {
						System.out.println("***ERROR: Number should be positive!");
						}
				else if (num != 0)   {
						System.out.println("***ERROR: Value already in list!");
						}
				}//WHILE

		}//addHiihtaja


  public static void RemoveHiihtaja(List omHiihtajat) throws IOException   {

		int num = 0;

		num = Parser.readInt   ("    Give number of competitor(Remov)>");

		if (num > 0)   {
				omHiihtajat.removeFromList(num);
				System.out.println("***INFO: competitor removed");
				omHiihtajat.output();
				}
		else   {
				System.out.println("***ERROR: Give a positive competitorNumber");
				}

		} //RemoveHiihtaja


  public static void EditHiihtaja(List omHiihtajat) throws IOException  {

		int Valinta;

		int newNum;
		int num = 1;
		String nim;
		int luo;
		double iha;
		double lai;

		boolean found;

		Knot pointer;

		while (num != 0)   {
				num = Parser.readInt("    Give number of competitor(Edit | 0-menu) >");
				pointer = omHiihtajat.findKnot(num);

				if (pointer != null)   {
						System.out.println("Contents of the Knot to be modified:");
						pointer.output();

						System.out.println("What do you wish to change?");
						System.out.println("    1-Competitors number");
						System.out.println("    2-Competitors name");
						System.out.println("    3-Competitors class");
						System.out.println("    4-Competitors ideal time");
						System.out.println("    ***");
						System.out.println("    0-Not a thing!");

						Valinta = Parser.readInt(">");

						switch (Valinta)   {

						case 1:
								newNum = Parser.readInt("    Give a new number for competitor>");

								found = omHiihtajat.queueNumero(newNum);

								if (found)   {
										System.out.println("***ERROR: number in use!");
										System.out.println("***INFO: Number has not been changed");
										}
								else if (num > 0)  {
										System.out.println("***INFO: Number has succesfully been changed.");
										omHiihtajat.removeFromList(num);
										pointer.setNumero(newNum);
										omHiihtajat.addToList(pointer);
										}
								omHiihtajat.output();
								break;

						case 2:
								nim = Parser.readLine("    Give a new name for competitor  >");
								pointer.setNimi(nim);
								System.out.println("***INFO: name succesfully changed");
								omHiihtajat.output();
								break;
						case 3:
								int tarkistus = 1;
								while(tarkistus != 0)	{
									luo = Parser.readInt("    Give a new class (values 1-3)   >");
									if ( 1 <= luo && luo <= 3) {
										pointer.setLuokka(luo);
										iha = pointer.getIHaika();
										Time arpa = new Time(luo, iha);
										lai = arpa.output();
										pointer.setLaika(lai);
										System.out.println("***INFO: class succesfully changed");
										tarkistus = 0;
										}
									else {
										System.out.println("***ERROR: Value must be 1-3");
										}
									}
								omHiihtajat.output();
								break;
						case 4:
								iha = Parser.readDouble("    Give a new ideal time (sec)     >");
								pointer.setIHaika(iha);
								luo = pointer.getLuokka();
								Time arpa = new Time(luo, iha);
								lai = arpa.output();
								pointer.setLaika(lai);
								System.out.println("***INFO: idealtime succesfully changed");
								omHiihtajat.output();
								break;
						default:
								omHiihtajat.output();
						} //SWITCH
						} //IF
				else if ( num < 0 )   {
						System.out.println("***ERROR: Number should be positive!");
						}
				else if ( num > 0 )   {
						System.out.println("***ERROR: Value not in List");
						}


				} //WHILE

		} //EditHiihtajat
                                        

  public static void SearchHiihtajaNum(List omHiihtajat) throws IOException  {

		int num = 0;

		boolean found;

		num = Parser.readInt("    Give the number to search for   >");
		found = omHiihtajat.queueNumero(num);
		if (found)   {
				System.out.println("***INFO: Competitor found");
				//omHiihtajat.output();
				Knot tmp;
				tmp = omHiihtajat.findKnot(num);
				tmp.output();
				}
		else   {
				System.out.println("***INFO: Competitor NOT found!");
				}

		} //SearchHiihtajaNum



  public static void RemoveList(List omHiihtajat)   {

		int num = 0;
		String dest;

		System.out.println("***WARNING: The whole List will be destroyed");
		System.out.println("Do you wish to continue? (y)es or (n)o");

		dest = Parser.readLine(">");

		if (dest.equals("y"))   {
				System.out.println("***INFO: List cleared");
				omHiihtajat.EraseList();
				}
		else   {
				System.out.println("***INFO: List NOT cleared");
				}

		} //RemoveList

                      

  public static void SaveList(List omHiihtajat) throws IOException  {

		String Fname;

		System.out.println("The list will be written in a file. You must");
		System.out.println("specify the filename before proceeding.");
		System.out.println("Example: a:\\list.dat");

		Fname = Parser.readLine(">");

		omHiihtajat.saveToFile(Fname);
		System.out.println("***INFO: List saved succesfully");

		} //SaveList

  public static void LoadList(List omHiihtajat) throws IOException  {

		String Fname;

		System.out.println("The list will be read from a file. You must");
		System.out.println("specify the filename before proceeding.");
		System.out.println("Example: a:\\list.dat");

		Fname = Parser.readLine(">");

		omHiihtajat.readFromFile(Fname);

		} //LoadList

}

                     














